import { select } from 'd3';
import { vizData } from './vizData';
import { makeData } from './makeData';

// //select('body').append('svg'); // returns a selection of the svg element

const width = window.innerWidth;
const height = window.innerHeight;

const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

// // data processing is tightly coupled with visualization code
// // const data = range(15);
// // svg
// //   .selectAll('circle') // all circles within the SVG; right now = none
// //   .data(data) // calling .data -> d3 data join -> enter/update/exit
// //   .enter() // enter selection
// //   .append('circle') // append circles to enter selection
// //   .attr('r', 20)
// //   .attr('cx', (d) => d * 60 + 50)
// //   .attr(
// //     'cy',
// //     (d) => 250 + Math.sin(d * 0.5) * 200
// //   ); // Math is built-in

// // enter selection: data element that does not correspond to DOM element

// // de-coupling
// // const data = range(15).map((d) => ({
// //   x: d * 60 + 50,
// //   y: 250 + Math.sin(d * 0.5) * 200,
// //   r: 20,
// // }));
// // console.log(data)

// // svg
// //   .selectAll('circle')
// //   .data(data)
// //   .enter()
// //   .append('circle')
// //   .attr('r', (d) => d.r)
// //   .attr('cx', (d) => d.x)
// //   .attr('cy', (d) => d.y);


// animating
let t = 0;
setInterval(() => {
  const n = 10 + Math.sin(t * 5);
  const data = makeData(n, t);
  //vizData(svg, data);
  svg.call(vizData, data); // selection.call
  // first argument is function; function should expect selection as its first arg + the other args to .call
  t = t + 0.01;

//   // const circles = svg
//   //   .selectAll('circle')
//   //   .data(data);
//   // const circlesEnter = circles
//   //   .enter()
//   //   .append('circle')
//   //   .attr('r', (d) => d.r);
//   // circles
//   //   .merge(circlesEnter) // first run = enter selection; then = update
//   //   .attr('cx', (d) => d.x)
//   //   .attr('cy', (d) => d.y);
//   // circles.exit().remove(); // done automatically with the .join

  
}, 1000 / 60); // 60 frames per second
